﻿var joe = new Customer { FirstName = "Joe", LastName = "Black" };
var john = new Employee { FirstName = "John", LastName = "Doe" };
var jack = new Helper { FirstName = "Jack" };

IncreaseSalary(john);
Console.WriteLine();
// Error: Argument 1: cannot convert from 'Customer' to 'IPersonOnPayroll'
// IncreaseSalary(joe);

void IncreaseSalary(IPersonOnPayroll person)
{
    Console.WriteLine($"IncreaseSalary: increasing for {person} ...");
}

abstract record class Person
{
    public string? FirstName { get; set; }
    public string? LastName { get; set; }
}

interface IPersonOnPayroll { }
interface IExternalPerson { }

record class Customer : Person, IExternalPerson { }
record class Employee : Person, IPersonOnPayroll { }
record class Helper : Person, IPersonOnPayroll, IExternalPerson { }
